﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using System.Diagnostics;

namespace CompositeChart
{
    public partial class Form1 : Form
    {
        private NumericTimeSeries series1;
        private NumericTimeSeries series2;
        private NumericTimeSeries series3;
        private CompositeLegend myLegend;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraChart1.ChartType = ChartType.Composite;

            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            //Create first  Y axis
            AxisItem axis1 = new AxisItem();
            axis1.Extent = 20;
            axis1.DataType = AxisDataType.Numeric;
            axis1.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis1.OrientationType = AxisNumber.Y_Axis;
            axis1.LineColor = Color.Red;
            area.Axes.Add(axis1);

            //Create second  Y axis
            AxisItem axis2 = new AxisItem();
            axis2.Extent = 70;
            axis2.DataType = AxisDataType.Numeric;
            axis2.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis2.OrientationType = AxisNumber.Y_Axis;
            axis2.LineColor = Color.Blue;
            area.Axes.Add(axis2);

            //Create third  Y axis
            AxisItem axis3 = new AxisItem();
            axis3.Extent = 120;
            axis3.DataType = AxisDataType.Numeric;
            axis3.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axis3.OrientationType = AxisNumber.Y_Axis;
            axis3.LineColor = Color.Yellow;
            area.Axes.Add(axis3);


            //Create X axis - time axis
            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.Time;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel;
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            area.Axes.Add(axisX);

            //Create a ChartLayer for each series
            //ChartLayer for series1
            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.LineChart;
            myColumnLayer.ChartArea = area;




            //ChartLayer for series2
            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.LineChart;
            myColumnLayer2.ChartArea = area;

            //ChartLayer for series3
            ChartLayerAppearance myColumnLayer3 = new ChartLayerAppearance();
            myColumnLayer3.ChartType = ChartType.LineChart;
            myColumnLayer3.ChartArea = area;

            //Create series1
            series1 = new NumericTimeSeries();
            series1.Label = "test";
            series1.PEs.Add(new PaintElement(Color.Red));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today, 200, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(1), 300, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(2), 100, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(3), 150, "test", false));

            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(4), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(5), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(6), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(7), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(8), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(9), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(10), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(11), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(12), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(13), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(14), 150, "test", false));
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(15), 150, "test", false));


            myColumnLayer.Series.Add(series1);
            ultraChart1.CompositeChart.Series.Add(series1);
            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axis1;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);


            //Create series2
            series2 = new NumericTimeSeries();
            series2.Label = "test2";
            series2.PEs.Add(new PaintElement(Color.Blue));
            series2.Points.Add(new NumericTimeDataPoint(DateTime.Today, 10, "test2", false));
            series2.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(1), 35, "test2", false));
            series2.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(2), 40, "test2", false));
            series2.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(3), 15, "test2", false));
            myColumnLayer2.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);
            myColumnLayer2.AxisX = axisX;
            myColumnLayer2.AxisY = axis2;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer2);

            //Create series3
            series3 = new NumericTimeSeries();
            series3.Label = "test3";
            series3.PEs.Add(new PaintElement(Color.Yellow));
            series3.Points.Add(new NumericTimeDataPoint(DateTime.Today, 400, "test3", false));
            series3.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(1), 215, "test3", false));
            series3.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(2), 420, "test3", false));
            series3.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(3), 545, "test3", false));
            myColumnLayer3.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);
            myColumnLayer3.AxisX = axisX;
            myColumnLayer3.AxisY = axis3;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer3);


            myLegend = new CompositeLegend();
            myLegend.ChartLayers.Add(myColumnLayer);
            myLegend.ChartLayers.Add(myColumnLayer2);
            myLegend.ChartLayers.Add(myColumnLayer3);
            myLegend.ChartLayers[1].LegendItem = LegendItemType.Auto;
            myLegend.Bounds = new Rectangle(0, 85, 15, 15);
            myLegend.BoundsMeasureType = MeasureType.Percentage;
            myLegend.PE.ElementType = PaintElementType.Gradient;
            myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            myLegend.PE.Fill = Color.CornflowerBlue;
            myLegend.PE.FillStopColor = Color.Transparent;
            myLegend.Border.CornerRadius = 10;
            myLegend.Border.Thickness = 1;

            this.ultraChart1.CompositeChart.Legends.Add(myLegend);
        }

        //Add new random points for series1
        private void ultraButton1_Click(object sender, EventArgs e)
        {
            series1.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(RandDays()), RandValue(), "test", false));
        }

        //Add new random points for series1
        private void ultraButton2_Click(object sender, EventArgs e)
        {
            series2.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(RandDays()), RandValue(), "test2", false));
        }

        //Add new random points for series1
        private void ultraButton3_Click(object sender, EventArgs e)
        {
            series3.Points.Add(new NumericTimeDataPoint(DateTime.Today.AddDays(RandDays()), RandValue(), "test3", false));
        }

        private int RandDays()
        {
            Random rndm = new Random();
            return rndm.Next(1, 20);
        }

        private double RandValue()
        {
            Random rndm = new Random();
            return rndm.Next(1, 1000);
        }

        private void ultraOptionSet1_ValueChanged(object sender, EventArgs e)
        {
            switch (ultraOptionSet1.CheckedIndex)
            {
                case 0:
                    myLegend.Bounds = new Rectangle(0, 85, 15, 15);
                    myLegend.LabelStyle.Dx = 0;

                    myLegend.LabelStyle.Dy = 0;
                    break;
                case 1:
                    myLegend.Bounds = new Rectangle(85, 5, 15, 5);
                    myLegend.LabelStyle.Dx = -15;
                    myLegend.LabelStyle.Dy = 5;
                    break;
                case 2:
                    myLegend.Bounds = new Rectangle(85, 65, 15, 5);
                    myLegend.LabelStyle.Dx = 0;
                    myLegend.LabelStyle.Dy = 0;
                    break;
                default:
                    myLegend.Bounds = new Rectangle(85, 65, 15, 5);
                    break;
            }
        }

        private void ultraNumericEditor1_ValueChanged(object sender, EventArgs e)
        {
            myLegend.LabelStyle.Font = new Font("Arial", (int)ultraNumericEditor1.Value);

        }

        private void ultraChart1_ChartDataClicked(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
        }

        private void ultraChart1_MouseHover(object sender, EventArgs e)
        {

        }

        private void ultraChart1_DataItemOver(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
            Debug.WriteLine(e.ColumnLabel);
        }
    }
}